{ EXAMPLE -----V }
{ UNCRUNCH (INITDATA,ScreenAddr[ (1*2) + (1*160) -162],INITDATA_LENGTH); }

unit CRUNCH;

interface

USES DOS;

   type ScreenType = array [0..3999] of Byte;
   var ScreenAddr : ScreenType absolute $B800:$0000;
   var MonoScreenAddr : ScreenType absolute $B000:$0000;

procedure dUNCRUNCH(var dAddr1; X,Y,dBlkLen:Integer);
procedure UNCRUNCH (var Addr1,Addr2; BlkLen:Integer);

implementation

procedure dUNCRUNCH(var dAddr1; X,Y,dBlkLen:Integer);

Function Get_Video_Mode:byte;
var
   Regs : registers;
begin
   with Regs do
   begin
       Ax := $0F00;
       Intr($10,Regs);
       Get_Video_Mode := Al;
   end; {with}
end; {of proc Video_Mode}

Function MONOman : boolean;
begin
 if Get_Video_Mode = 7 then
    MONOman := true
 else
    MONOman := false;
end;

BEGIN  { Procedure dUNCRUNCH }
 If MONOman then Uncrunch(dAddr1,MonoScreenAddr[ (X*2) + (Y*160) -162],dBlkLen)
            else Uncrunch(dAddr1,ScreenAddr[ (X*2) + (Y*160) -162],dBlkLen);
END;   { Procedure dUNCRUNCH }




procedure UNCRUNCH (var Addr1,Addr2; BlkLen:Integer);
begin

  inline (
    $1E/               {       PUSH    DS}
    $C5/$B6/Addr1/     {       LDS     SI,[BP+Addr1]  ;Source Address}
    $C4/$BE/Addr2/     {       LES     DI,[BP+Addr2]  ;Destination Addr}
    $8B/$8E/BlkLen/    {       MOV     CX,[BP+BlkLen] ;Length of block}
    $8B/$D7/           {       MOV     DX,DI          ;Save X coordinate for later.}
    $33/$C0/           {       XOR     AX,AX          ;Set Current attributes.}
    $FC/               {       CLD                    ;Clear direction flag.}
    $AC/               {LOOPA: LODSB                  ;Get next character.}
    $3C/$1B/           {       CMP     AL,27          ;Does user want to toggle the blink}
    $75/$05/           {       JNZ     ForeGround     ;attibute?}
    $80/$F4/$80/       {       XOR     AH,128         ;Done.}
    $EB/$4D/           {       JMP     Short Next}
                       {ForeGround:}
    $3C/$10/           {       CMP     AL,16          ;If less than 16, then change the}
    $73/$07/           {       JNC     BackGround     ;foreground color.  Otherwise jump.}
    $80/$E4/$70/       {       AND     AH,70H         ;Strip off old foreground.}
    $0A/$E0/           {       OR      AH,AL}
    $EB/$42/           {       JMP     Short Next}
                       {BackGround:}
    $3C/$18/           {       CMP     AL,24          ;If less than 24, then change the}
    $74/$13/           {       JZ      NextLine       ;background color.  If exactly 24,}
    $73/$19/           {       JNC     MultiOutput    ;then jump down to next line.}
    $2C/$10/           {       SUB     AL,16          ;Otherwise jump to multiple output}
    $02/$C0/           {       ADD     AL,AL          ;routines.}
    $02/$C0/           {       ADD     AL,AL}
    $02/$C0/           {       ADD     AL,AL}
    $02/$C0/           {       ADD     AL,AL}
    $80/$E4/$8F/       {       AND     AH,8FH         ;Strip off old background.}
    $0A/$E0/           {       OR      AH,AL}
    $EB/$2B/           {       JMP     Short Next}
                       {NextLine:}
    $81/$C2/$A0/$00/   {       ADD     DX,160         ;If equal to 24,}
    $8B/$FA/           {       MOV     DI,DX          ;then jump down to}
    $EB/$23/           {       JMP     Short Next     ;the next line.}
                       {MultiOutput:}
    $3C/$19/           {       CMP     AL,25          ;If equal to 25,}
    $75/$0B/           {       JNZ     NotMultiSpaces ;then using the}
    $AC/               {       LODSB                  ;following code as}
    $51/               {       PUSH    CX             ;a count, output}
    $32/$ED/           {       XOR     CH,CH          ;said number of}
    $8A/$C8/           {       MOV     CL,AL          ;spaces.}
    $B0/$20/           {       MOV     AL,32}
    $EB/$0D/$90/       {       JMP     StartOutput    ;Use below loop.}
                       {NotMultiSpaces:}
    $3C/$1A/           {       CMP     AL,26          ;If equal to 26, then using}
    $75/$0F/           {       JNZ     NormalLetter   ;the following two codes, display}
    $AC/               {       LODSB                  ;<x> number of <y> characters.}
    $49/               {       DEC     CX             ;Adjust main counter.}
    $51/               {       PUSH    CX             ;Display as many of}
    $32/$ED/           {       XOR     CH,CH          ;whatever the user}
    $8A/$C8/           {       MOV     CL,AL          ;wants.}
    $AC/               {       LODSB                  ;Get character.}
                       {StartOutput:}
    $E3/$03/           {       JCXZ    Stop           ;Abort if already at zilch.}
    $AB/               {LOOPB: STOSW}
    $E2/$FD/           {       LOOP    LOOPB}
    $59/               {Stop:  POP     CX}
    $49/               {       DEC     CX             ;Adjust main counter.}
                       {NormalLetter:}
    $AB/               {       STOSW                  ;Save screen letter.}
    $E3/$02/           {Next:  JCXZ    Done           ;Get next, unless CX}
    $E2/$A5/           {       LOOP    LOOPA          ;has already gone to zero.}
    $1F);              {Done:  POP     DS}

end; {UNCRUNCH}

BEGIN
END.

