{$R-,S-,I-,D-,F+,V-,B-,N-,O+ }
{$M 65500,0,0 }

{$DEFINE OVERLAY}

unit init;

interface

uses crt,dos,CrUnCh,
     gentypes,modem,statret,configrt,gensubs,subs1,windows,subs2, SPACE;

procedure validconfiguration;
procedure initboard (checkfiles30:boolean);

implementation

{$I INITDATA}

var an_errorcode : word;

procedure writeii(st : string);
var x : byte;
begin
  if length(st) = 0 then
   begin
   gotoxy(1,10);
   writeln('----- Initializing Board -----'); 
   end;
   gotoxy(1,11);
   writeln('      > '+st+'                ');
end;

procedure validconfiguration;
var errs:integer;
    cnt:integer;
    flag:boolean;

  procedure error (q:anystr);
  begin
    if errs=0 then writeln (usr,'Configuration Errors:');
    errs:=errs+1;
    writeln (usr,errs,'. ',q)
  end;

  procedure ispath (var x:lstr; name:lstr);
  begin
    if not exist(x+'con') then error (name+' Path bad: '+x)
  end;

  procedure isfilename (var xx:lstr; fn:lstr);
  begin
   if not exist(xx) then error (fn+' Filename bad: '+xx)
  end;

  procedure isstring (x:anystr; name:lstr);
  var cnt:integer;
  begin
    if length(x)=0 then begin
      error (name+' has not been set!');
      exit
    end;
    for cnt:=1 to length(x) do if not (x[cnt] in [#32..#255])
      then begin
        error ('Bad '+name+' string');
        exit
      end
  end;

  procedure isinteger (n,r1,r2:longint; name:lstr);
  begin
    if (n<r1) or (n>r2) then error ('Bad '+name+' value: '+strr(n))
  end;

begin
  writeii('Configuration');
  Status_Line_Mode := 1; {*****}
  errs:=0;
  isstring (sysopname,'Sysop Name');
  ispath (textdir,'Path to Message Base');
  ispath (uploaddir,'Path to Ascii Uploads');
  ispath (boarddir,'Path to Sub-board Files');
  ispath (textfiledir,'Path to Menus, etc.');
  ispath (doordir,'Path to DOOR Batch Files');
  isinteger (defbaudrate,1200,115200,'default Baud Rate');
  isinteger (usecom,1,8,'COM: port');
  isinteger (mintimeout,1,maxint,'input time out');
  isinteger (sysoplevel,1,maxint,'Co-Sysop Level');
  flag:=true;
  for cnt:=1 to 100 do if flag and (usertime[cnt]<1) then begin
    flag:=false;
    error ('Time per day has non-positive entries')
  end;
  if errs>0 then halt(e_badconfig)
end;

procedure initboard (checkfiles30:boolean);

  procedure formatmfile;
  var m:mailrec;
  begin
    rewrite (mfile);
    fillchar (m,sizeof(m),255);
    write (mfile,m)
  end;

  procedure openmfile;
  var i:integer;
  begin
    writeii('Mail File');
    close (mfile);
    i:=ioresult;
    assign (mfile,setupdir+'Mail');
    reset (mfile);
    i:=ioresult;
    if i<>0
      then if i=2
        then formatmfile
        else begin
          writeln (usr,'Fatal error: Unable to open mail file!');
          halt (e_fatalfileerror)
        end
  end;

  procedure closetfile;
  var n:integer;
  begin
    close (tfile);
    n:=ioresult;
    close (mapfile);
    n:=ioresult
  end;

  procedure formattfile;
  var cnt,p:integer;
      r:real;
      buff:buffer;
      x:string[1];
  const dummystr:sstr='Blank!! ';
  begin
    write (usr,'Message Base not found.  Create new one [y/N]? ');
    buflen:=1;
    readline (x);
    if (length(x)=0) or (upcase(x[1])<>'Y') then halt (e_fatalfileerror);
    writeln (usr,'Please Hold..Rewriting Map File!');
    rewrite (mapfile);
    if ioresult<>0 then begin
      writeln (usr,'Unable to create Message Base.');
      halt (e_fatalfileerror)
    end;
    p:=-2;
    for cnt:=0 to numsectors do write (mapfile,p);
    p:=1;
    for cnt:=1 to sectorsize do begin
      buff[cnt]:=dummystr[p];
      p:=p+1;
      if p>length(dummystr) then p:=1
    end;
    rewrite (tfile);
    if ioresult<>0 then begin
      writeln (usr,'Unable to create Message Base.');
      halt (e_fatalfileerror)
    end;
    for cnt:=0 to 5 do write (tfile,buff)
  end;

  procedure opentfile;
  var i,j:integer;
  begin
    writeii('Message Files');
    closetfile;
    assign (tfile,textdir+'Text');
    assign (mapfile,textdir+'BlockMap');
    reset (tfile);
    i:=ioresult;
    reset (mapfile);
    j:=ioresult;
    if (i<>0) or (j<>0) then formattfile;
    firstfree:=-1
  end;

  procedure openufile;
  var u:userrec;
      n,cnt:integer;

    procedure createuhfile;
    var cnt:integer;
    begin
      rewrite (uhfile);
      if ioresult<>0 then begin
        writeln (usr,'Creating User Index files requires that you RUN the BBS AGAIN.');
        halt (e_fatalfileerror)
      end;
      seek (ufile,0);
      while not eof(ufile) do begin
        read (ufile,u);
        write (uhfile,u.handle)
      end
    end;

  begin
    close (ufile);
    writeii('USERS file');
    assign (ufile,setupdir+'Users');
    reset (ufile);
    n:=ioresult;
    if n=0 then begin
      numusers:=filesize(ufile)-1;
      assign (uhfile,setupdir+'Userindx');
      reset (uhfile);
      if ioresult<>0
        then createuhfile
        else if filesize(uhfile)<>filesize(ufile) then begin
          close (uhfile);
          createuhfile
        end;
      exit
    end;
    close (ufile);
    n:=ioresult;
    rewrite (ufile);
    fillchar (u,sizeof(u),0);
    write (ufile,u);
    u.handle:=sysopname;
    u.note:='[ SysOp ]';
    u.macro1:=u.handle;
    u.password:='BBS';
    u.phonenum:='1234567890';
    u.timetoday:=3500;
    u.level:=sysoplevel+1;
    u.udlevel:=sysoplevel+1;
    u.udpoints:=sysoplevel+1;
    u.gflevel:=sysoplevel+1;
    u.config:=[lowercase,eightycols,linefeeds,postprompts,asciigraphics,ansigraphics,showtime];
    u.emailannounce:=-1;
    u.infoform1:=-1;
    u.infoform2:=-1;
    u.infoform3:=-1;
    u.infoform4:=-1;
    u.infoform5:=-1;
    u.displaylen:=24;
    u.statcolor   :=lightgreen;  
    u.regularcolor:=lightcyan;
    u.promptcolor :=cyan;
    u.inputcolor  :=14;
    u.menutype:=0;
    u.laston:=now;
    fillchar (u.access2,32,255);
    if useconmode then u.config:=u.config+[ansigraphics,fseditor];
    write (ufile,u);
    numusers:=1;
    createuhfile
  end;

  procedure initfile (var f:file);
  var fi:fib absolute f;
  begin
    fi.handle:=0;
    fi.name[0]:=chr(0)
  end;

  procedure openlogfile;

    procedure autodeletesyslog;
    var mx,cnt:integer;
        l:logrec;
    begin
      dontanswer;
      write (usr,'Auto-deleting System Log - please stand by ... ');
      mx:=filesize(logfile) div 2;
      for cnt:=1 to mx do begin
        seek (logfile,cnt+mx-1);
        read (logfile,l);
        seek (logfile,cnt-1);
        write (logfile,l)
      end;
      seek (logfile,mx-1);
      truncate (logfile);
      writeln (usr,'Done.');
      doanswer
    end;

  begin
    writeii('System Log');
    assign (logfile,setupdir+'SYSLOG');
    reset (logfile);
    if ioresult<>0 then begin
      rewrite (logfile);
      if ioresult<>0 then begin
        writeln (usr,'Unable to create log file');
        halt (e_fatalfileerror)
      end
    end;
    if filesize(logfile)>maxsyslogsize then autodeletesyslog
  end;

  procedure loadsyslogdat;
  var tf:text;
      q:lstr;
      b1,b2,p,s,n:integer;
  begin
    numsyslogdat:=0;
    with syslogdat[0] do begin
      menu:=0;
      subcommand:=0;
      text:='SYSLOG.DAT entry not found: %'
    end;
    assign (tf,setupdir+'syslog.dat');
    reset (tf);
    if ioresult=0 then begin
      while not eof(tf) do begin
        readln (tf,q);
        p:=pos(' ',q);
        if p<>0 then begin
          val (copy(q,1,p-1),b1,s);
          if s=0 then begin
            delete (q,1,p);
            p:=pos(' ',q);
            if p<>0 then begin
              val (copy(q,1,p-1),b2,s);
              if s=0 then begin
                delete (q,1,p);
                if numsyslogdat=maxsyslogdat
                  then writeln (usr,'Too many SYSLOG.DAT entries')
                  else begin
                    numsyslogdat:=numsyslogdat+1;
                    with syslogdat[numsyslogdat] do begin
                      menu:=b1;
                      subcommand:=b2;
                      text:=copy(q,1,30)
                    end
                  end
              end
            end
          end
        end
      end;
      textclose (tf)
    end;
    if numsyslogdat=0 then writeln (usr,'SYSLOG.DAT file missing or invalid')
  end;

  procedure doesfilesequal30;
  var f:array [1..14] of file;
      cnt,i:integer;
  begin
    {$IFNDEF OVERLAY}
    for cnt:=1 to 14 do begin
      assign (f[cnt],'CON');
      reset (f[cnt]);
      i:=ioresult;
      if i<>0 then begin
        writeln (usr,^M^G^J'ERROR:  FILES=30 must be placed in your CONFIG.SYS');
        halt (e_files30)
      end
    end;
    for cnt:=14 downto 1 do close(f[cnt])
    {$ENDIF}
  end;

procedure readsysopmacros;
var ff:text;
    ummbobway,killer:integer;
begin
 writeii('SysOp Macros');
 assign (ff,setupdir+'SYSOP.MAC');
 ummbobway:=0;
 if not exist (setupdir+'SYSOP.MAC') then begin
  sysopmacro1:=sysopname;
  sysopmacro2:=longname;
  sysopmacro3:='Sysop Macro #3';
  sysopmacro4:='Sysop Macro #4';
  sysopmacro5:='Sysop Macro #5';
  sysopmacro6:='Sysop Macro #6';
  sysopmacro7:='Sysop Macro #7';
  sysopmacro8:='Sysop Macro #8';
  sysopmacro9:='Sysop Macro #9';
  sysopmacro10:='Sysop Macro #10';
 end else
 if exist (setupdir+'SYSOP.MAC') then begin
  reset (ff);
  readln (ff,sysopmacro1);
  readln (ff,sysopmacro2);
  readln (ff,sysopmacro3);
  readln (ff,sysopmacro4);
  readln (ff,sysopmacro5);
  readln (ff,sysopmacro6);
  readln (ff,sysopmacro7);
  readln (ff,sysopmacro8);
  readln (ff,sysopmacro9);
  readln (ff,sysopmacro10);
  close (ff);
 end
end;

var k,klux:char;
    cnt:integer;
begin
  with textrec(system.output) do begin
    openfunc:=@opendevice;
    closefunc:=@closedevice;
    flushfunc:=@writechars;
    inoutfunc:=@writechars
  end;
  with textrec(system.input) do begin
    inoutfunc:=@readcharfunc;
    openfunc:=@ignorecommand;
    closefunc:=@ignorecommand;
    flushfunc:=@ignorecommand
  end;
  if checkfiles30 then doesfilesequal30;
  fillchar (urec,sizeof(urec),0);
  urec.config:=[lowercase,eightycols,asciigraphics,ansigraphics];
  { screendef := 1;  for WAITFARACALL? }
  iocode:=0;
  linecount:=0;
  sysopavail:=bytime;
  errorparam:='';
  errorproc:='';
  unam:='> OFFLINE <';
{  timeleft := 666;  something like that.. }
  chainstr:='';
  chatreason:='!BBS!';
  sendstr:='';
  ulvl:=0;
  unum:=-1;
  logonunum:=-2;
  echoit:=true;
  break:=false;
  atmenu:=false;    { if you're at a menu or not }
  nochain:=false;   { doesn't continue with other write's etc.. }
  nobreak:=true;    { false before... }
  wordwrap:=false;  { does the wrapping of words to the next line }
  beginwithspacesok:=false;
  dots:=false;
  online:=false;
  local:=true;
  chatmode:=false;
  texttrap:=false;
  printerecho:=false;
  usecapsonly:=false;
  uselinefeeds:=true;
  curattrib:=0;
  buflen:=80;
  baudrate:=defbaudrate;
  parity:=false;
  timelock:=false;
  ingetstr:=false;
  modeminlock:=false;
  modemoutlock:=false;
  tempsysop:=false;
  sysnext:=false;
  forcehangup:=false;
  requestbreak:=false;
  disconnected:=false;
  notitle:=false;
  nosendprompt:=false;
  emailing:=false;
  periods:=false;
  validprotos:=['X','Y','Z','J','L','G','O','1','S','K','R','P','W','4'];
  cursection:=mainsysop;
  regularlevel:=0;
  {usecom:=2;}  { ** default com 1 }
  if paramcount=1 then usecom:=2;
  com_install (usecom,an_errorcode);

  setparam (usecom,baudrate,parity);
  doanswer;
  initwinds;
  for cnt:=1 to numsysfiles do initfile (sysfiles[cnt]);

  if checkfiles30 then {only done on init, thus do it here only }
    dUNCRUNCH (INITDATA,1,1,INITDATA_LENGTH);
  if checkfiles30 then writeii('') else writeii('CLOSING');

  loadsyslogdat;
  readstatus;
  openufile;
  opentfile;
  openlogfile;
  openmfile;
  readsysopmacros;
end;

procedure assignname (var t:text; nm:lstr);
begin
  with textrec(t) do begin
    move (nm[1],name,length(nm));
    name[length(nm)]:=#0
  end
end;

var r:registers;
begin
  checkbreak:=false;
  checkeof:=false;
  directvideo:=directvideomode;
  checksnow:=checksnowmode;
  r.ah:=15;
  intr ($10,r);
  if r.al=7
    then screenseg:=$b000
    else screenseg:=$b800;
  textrec(system.input).mode:=fminput;
  move (output,usr,sizeof(text));           { Set up device drivers }
  move (output,direct,sizeof(text));
  move (system.input,directin,sizeof(text));
  with textrec(direct) do begin
    openfunc:=@opendevice;
    closefunc:=@closedevice;
    flushfunc:=@directoutchars;
    inoutfunc:=@directoutchars;
    bufptr:=@buffer
  end;
  with textrec(directin) do begin
    mode:=fminput;
    inoutfunc:=@directinchars;
    openfunc:=@ignorecommand;
    flushfunc:=@ignorecommand;
    closefunc:=@ignorecommand;
    bufptr:=@buffer
  end;
  with textrec(usr) do bufptr:=@buffer;
  assignname (usr,'USR');
  assignname (direct,'DIRECT');
  assignname (directin,'DIRECT-IN');
  assignname (system.output,'OUTPUT');
  assignname (system.input,'INPUT')
end.
