{$R-,S-,I-,D-,F+,V-,B-,N-,L+ }
{$M 65500,0,0 }

unit space; { SpacePirates Unit -> Stongholds, Docks, Ships, Battles etc }

interface

uses crt,dos,
     gentypes,configrt,statret,textret,userret,mailret,modem,
     gensubs,subs1,subs2,windows,chatstuf,mainr1,mainr2,overret1,Strnttt5;

{ Global Variables }

CONST   NumQuads = 1000;
        MinDocks = 50;
        MinSpecials = 20;
        SpaceDir = 'SPACE\';

type    Quadrant_Rec = record
                     Num     : integer;
                     Dock    : integer;
                     Warps   : array[1..20] of integer;
                     Special : integer;
                     end;

        Mine_Record = record
                     Num : integer;
                     class  : integer;
                     who    : integer;
                     end;

        Planet_Rec  = record
                     Name : mstr;
                     xint1 : integer;
                     xint2 : integer;
                     xint3 : integer;
                     xint4 : integer;
                     xint5 : integer;
                     xint6 : integer;
                     xint7 : integer;
                     xint8 : integer;
                     xint9 : integer;
                     xint10: integer;
                     end;


        Special_Rec = record
                     Cruz   : array[1..20] of integer;
                     Planet : Planet_Rec;
                     Mines  : Mine_Record;
                     xint1  : integer;
                     xint2  : integer;
                     xint3  : integer;
                     xint4  : integer;
                     xint5  : integer;
                     end;

        Dock_Rec = record
                     Num : integer;
                     Name : mstr;
                     Owner : integer; { 0 if computer }
                     class: byte;
                     Arms  : integer; { -30000 to +30000 }
                     Food  : integer;
                     Fuel  : integer;
                     Drugs : integer; { these two illegal }
                     Contra: integer; { contraband }
                     xint1,xint2,xint3,xint4,xint5 : integer;
                     Credits : integer;
                     Fighters: integer;
                     Sheilds : integer;
                     TimeLast : sstr;
                     DateLast : sstr;
                     WhoLast  : lstr;
                     end;

VAR     UnivFile : file of Quadrant_Rec;   {UNIVERSE}
        SpecialFile : file of special_rec; {SPECIALS}
        DockFile : file of Dock_Rec;       {DOCKS}
        CurQuad : Quadrant_Rec;
        CurDock : Dock_rec;
        CurSpecial : Special_Rec;
        Qqq : boolean;

{ Procedures }

procedure Docking_Sequence;
procedure Engage_Battle;
procedure Christen_Ship;
procedure Trade_Goods;
procedure Big_Bang;
procedure Move_Ship;
procedure Land_Planet;
procedure LoadQuad(qnum:integer);
procedure SaveQuad;
procedure Display_Quad;
procedure DisplayDock;
procedure Test_Quads;
procedure OpenSpaceFiles;
procedure CloseSpaceFiles;
procedure EditSpaceStats;

implementation

procedure ChkIO(Wher : mstr);
var wty : integer;
begin
  wty := ioresult;
  if wty <> 0 then writeln(wher+' - I/O ERROR: '+int_to_str(wty)+^G^G); 
end;

procedure CloseSpaceFiles;
begin
 Close(SpecialFile);
 ChkIO('1');
 Close(DockFile);
 ChkIO('2');
 Close(UnivFile);
 ChkIO('3');
end;

procedure LoadSpecial;
begin
 seek(SpecialFile,curquad.special-1);
 ChkIO('4');
 read(SpecialFile,curSpecial);
 ChkIO('5');
end;

procedure LoadDock;
begin
 seek(DockFile,curquad.dock-1);
 ChkIO('6');
 read(dockFile,curdock);
 ChkIO('7');
end;

procedure SaveSpecial;
begin
 seek(SpecialFile,curquad.special-1);
 ChkIO('8');
 write(SpecialFile,curSpecial);
 ChkIO('9');
end;

procedure SaveDock;
begin
 seek(DockFile,curquad.dock-1);
 ChkIO('10');
 write(dockFile,curdock);
 ChkIO('11');
end;

procedure LoadQuad(qnum : integer);
begin
 if ((qnum <= NumQuads)and(qnum > 0)) then
 begin
  seek(univFile,QNum-1);
 ChkIO('12');
  read(univfile,curquad);
  urec.quad := curquad.num;
 ChkIO('13');
  if curquad.special <> 0 then LoadSpecial;
  if curquad.dock <> 0 then LoadDock;
 end; {ignore bad sector #s}
end; 

procedure SaveQuad;
begin
  seek(UnivFile,curquad.num-1);
 ChkIO('14');
  write(UnivFile,curquad);
 ChkIO('15');
  if curquad.special <> 0 then SaveSpecial;
  if curquad.dock <> 0 then SaveDock;
end;

procedure Docking_Sequence;
var ch : char;
begin
 writehdr('Docking Sequence');
 writeln('Approaching Docking Station...');
 writeln(^P'Clearence given to vessel "'^S+urec.shipname+
         ^P'" at '+timestr(now)+'.');
 writeln('Teleporting inside...');
 writeln('');
 repeat
  Displaydock;
  writeln('[Q]uit - Teleport back to ship');
  writeln('');
  write  ('Function: ');
  ch := readkey;
 until upcase(ch) = 'Q';
end;

procedure Engage_Battle;
begin
end;

procedure Christen_Ship;
begin
end;

procedure Trade_Goods;
begin
end;

procedure _WOpenfiles;
begin
  assign(UnivFile,forumdir+spacedir+'UNIVERSE');
 ChkIO('16');
  rewrite(univfile);
 ChkIO('17');
  assign(DockFile,forumdir+spacedir+'DOCKS');
 ChkIO('18');
  rewrite(DockFile);
 ChkIO('19');
  assign(SpecialFile,forumdir+spacedir+'SPECIAL');
 ChkIO('19.5');
  rewrite(SpecialFile);
 ChkIO('19.6');
end;

procedure OpenSpacefiles;
begin
 writeln(':: Space Files');
  assign(UnivFile,forumdir+spacedir+'UNIVERSE');
  close(univfile);
 ChkIO('20');
  reset(univfile);
 ChkIO('21');
  assign(DockFile,forumdir+spacedir+'DOCKS');
  close(dockfile);
 ChkIO('22');
  reset(DockFile);
 ChkIO('23');
  assign(SpecialFile,forumdir+spacedir+'SPECIAL');
  close(specialfile);
 ChkIO('23.5');
  reset(specialfile);
 ChkIO('23.6');
end;

procedure _DoFiles;
var zxc, xcv, cvb, tmpp : integer;
begin

 writestr(']] Universe Creation...');
 writestr(']] Enter random seed number: *');

 { UNIVERSE FILE }

 for zxc := 1 to NumQuads do
 begin
   curquad.num     := zxc;
   curquad.Dock    := 0;
   for xcv := 1 to 20 do
    curquad.Warps[xcv] := 0;
   if curquad.num = 1 then curquad.warps[1] := 2;
   if curquad.num = 1 then curquad.warps[2] := 3;
   if curquad.num = 2 then curquad.warps[1] := 1;
   if curquad.num = 3 then curquad.warps[1] := 1;
   curquad.Special := 0;
   write(UnivFile,curquad);
 end;

 Randseed := str_to_int(input);
 Randomize;

 writeln(']] Empty Universe created ('+int_to_str(numquads)+') Quadrants');

 { DOCK FILE }
 for xcv := 1 to MinDocks do
 begin
  with curdock do
  begin
                     Num := xcv;
                     Name := 'Federation Docking Station #'+int_to_str(xcv);
                     Owner := 0;
                     class:= random(4)+1; {1 thu 5}
                     Arms  := random(2000) - 1000;
                     Food  := random(2000) - 1000;
                     Fuel  := random(2000) - 1000;
                     Drugs := 0;
                     Contra:= 0;
                     xint1 :=0; xint2 :=0; xint3 :=0; xint4 :=0; xint5 :=0;
                     Credits := 15000;
                     Fighters:= 15000;
                     Sheilds := 1000;
                     TimeLast := 'Midnight';
                     DateLast := '12/25/3092';
                     WhoLast  := 'Nobody';
                     end;
  write(dockfile,curdock);

  { One in sector one }
  if xcv = 1 then cvb := 1 else cvb := random(NumQuads+1);
  loadquad(cvb);
  curquad.dock := xcv; 
  savequad;
 end;

 writeln(']] 21 Docking Stations Created!');

 { SPECIAL FILE }
 for zxc := 1 to MinSpecials do
 begin
  with curSpecial do
  begin
       for tmpp := 1 to 20 do
       Cruz[tmpp] := 0;
       Mines.Num := 0;
       Mines.class  := 0;
       Mines.who    := 0;
       Planet.Name := 'Allied Planets Colony #'+int_to_str(zxc);
       Planet.xint1 := random(2000) - 200;
       Planet.xint2 := random(2000) - 200;
       Planet.xint3 := random(2000) - 200;
       Planet.xint4 := random(1000) - 800;
       Planet.xint5 := random(1000) - 800;
       Planet.xint6 := 10;
       Planet.xint7 := 10;
       Planet.xint8 := 10;
       Planet.xint9 := 5;
       Planet.xint10:= 5;
       xint1  := 0;
       xint2  := 0;
       xint3  := 0;
       xint4  := 0;
       xint5  := 0;
       end;
  write(specialfile,curspecial);
  { One in sector one }
  if xcv = 1 then cvb := 1 else cvb := random(NumQuads+1);
  loadquad(cvb);
  curquad.special := xcv; 
  savequad;
 end;

 writeln(']] Special File Created! (20 Planets)');

 writeln(']]>> The beginning of time has started!');
end;

procedure Big_Bang;
begin
 if issysop then begin
 clrscr;
 writehdr('BIG BANG');
 writestr('Are you sure? [y/N] *');
 if yes then begin
              _WOpenfiles;
              _Dofiles;
              CloseSpaceFiles;
              OpenSpaceFiles; { normal closed/opening }
             end;
 end
end;

procedure Land_Planet;
begin
end;

function GetSystem : string;
begin
 GetSystem := 'Unknown';
 case ((curquad.num + 2) div 2) of
 0..50    : GetSystem := 'Allied Quadrants I';
 51..100  : GetSystem := 'Allied Quadrants II';
 101..150 : GetSystem := 'Solaris Gamma II';
 151..200 : GetSystem := 'Alpha Coronus IV';
 201..300 : GetSystem := 'The InterZone';
 { rest is unknown! }
 end;
end;

function Knone(sssx : string): string;
begin
 kNone := 'None.';
 if curquad.special <> 0 then kNone:=(sssx);
 if curquad.dock <> 0 then kNone:=(sssx);
end;

function ShowCruz : string;
var asd : integer;
begin
 if curquad.special <> 0 then begin
 for asd := 1 to 20 do
 begin
  if curspecial.cruz[asd] <> 0 then
     Showcruz:='['+int_to_str(curspecial.cruz[asd])+'] ';
     Showcruz:='Hmm it should not write here';
     { make this more verbose }
 end;
 end else ShowCruz :='None.';
end;

function ShowQuadz : string;
var qw : integer;
    er : lstr;
begin
 ER := '';
 for qw := 1 to 20 do
 begin
  if curquad.warps[qw] <> 0 then 
     begin
      ER := ER+^P'['^S+int_to_str(curquad.warps[qw])+^P'] ';
     end else qw := 20; { END IMMEDIATELY ON 0 }
 end;
 If ER = '' then ShowQuadz := 'None!!!' { Black Hole - random sector }
  else ShowQuadz := ER;
end;

procedure Display_Quad;
begin
 clrscr;
 writehdr('Quadrant ['+int_to_str(curquad.num)+']');
 writeln('Starsystem Name..: '^S+GetSystem);
 writeln('Docking Station..: '^S+knone(curdock.name));
 writeln('StarCruisers.....: '^S+ShowCruz);
 writeln('Fusion Mines.....: '^S+'None.');
 writeln('Orbitals.........: '^S+'None.');
 writeln('');
 writeln('Next Quadrants...: '^S+ShowQuadz);
end;

function GetUName : mstr;
var GUN : mstr;
begin
 if curdock.owner = 0 then GUN := 'Allied Trading Inc.' else
 GUN := '['+int_to_str(curdock.owner)+'] '+LookUpUName(curdock.owner);
 GetUName := GUN;
end;

procedure DisplayDock;
begin
 clrscr;
 with CurDock do
 begin
  writehdr(name);
  writestr('Number......:'^S+int_to_str(num));
  writestr('Owner #.....:'^S+GetUname);
  writestr('Class.......:'^S+int_to_str(class));
  writestr('Arms........:'^S+int_to_str(arms));
  writestr('Food........:'^S+int_to_str(food));
  writestr('Fuel........:'^S+int_to_str(fuel));
  writestr('Drugs.......:'^S+int_to_str(drugs));
  writestr('Contraband..:'^S+int_to_str(contra));
  writestr('Credits.....:'^S+int_to_str(credits));
  writestr('Fighters....:'^S+int_to_str(fighters));
  writestr('Sheilds.....:'^S+int_to_str(sheilds));
  writestr('Last Used...:'^S+datelast+' at '+timelast);
  writestr('Used by.....:'^S+wholast);
 end;
end;

procedure DeleteAWarp;
begin
end;

procedure AddWarpz(Nm,Mn : integer; return : boolean);
var qw : integer;
begin
 if Return then begin
  LoadQuad(Mn);
  qw := 0;
  repeat
   inc(qw);
  until ((curquad.warps[qw] = 0) or (qw > 19) or (curquad.warps[qw] = Nm));
  curquad.warps[qw] := Nm;
  SaveQuad;
 end; { if return }


 LoadQuad(Nm);
 qw := 0;
 repeat
  inc(qw);
 until ((curquad.warps[qw] = 0) or (qw > 19) or (curquad.warps[qw] = Mn));
 curquad.warps[qw] := Mn;                            { This avoids repeats }
 SaveQuad;
end;

procedure AddaWarp(Nm : integer);
begin
 writestr('Make a return Warp? [y/N] *');
 AddWarpz(Curquad.num,Nm,yes);
end;

function Poo(crap, shit : integer) : integer;
begin
  if crap = Shit then inc(crap,random(5)+1);
  if crap < 1 then crap := (1+random(35));
  if crap > numQuads then crap := NumQuads-(1+random(35));
  Poo := crap;
end;

procedure DoSuperWarps;
var zaq,bub,bubb : integer;
begin
 for zaq := 1 to NumQuads do
 begin

 Bub := random((zaq*2)+1);
 Bubb:= random(zaq-random(200));

 { SuperWarps = cool } AddWarpz(zaq,poo(Bub,zaq),true);
 if random(2) = 1 then Addwarpz(zaq,Poo(zaq+1,zaq),true);
 if random(1) = 1 then Addwarpz(zaq,Poo(Bubb,zaq),true);
 end;
end;

procedure SuperWarpMaker;
begin
 Qqq := false;
 if issysop then
 repeat
  writehdr('Super Warp Maker!');
  writeln('[D] Do it!');
  writeln('[Q] Quit');
  writeln('');
  writestr('Input: *');
  case upcase(Input[1]) of
   'D' : DoSuperWarps;
   'Q' : Qqq := true;
  end;
 until Qqq;
end;



procedure EditSingleWarps;
begin
 Qqq := false;
 if issysop then repeat
  writeln('Edit Quadrant ['+int_to_str(curquad.num)+'] Warp Connections');
  writeln('[D] Delete a Warp');
  writeln('[#] Add a warp to #');
  writeln('[Q] Quit'^m);
  writestr('Input: *');
  if Input = 'd' then DeleteAWarp;
  if Input = 'q' then Qqq := true;
  if str_to_int(Input) > 0 then AddaWarp(str_to_int(Input));
 until Qqq;
end;

procedure EditWarps;
begin
 Qqq := false;
 if issysop then repeat
  Writehdr('WarpMaker');
  writeln('[S] Super Warp Maker');
  writeln('[E] Edit Warps of a Quad');
  writeln('[Q] Quit'^m);
  writestr('INPUT: *');
  case upcase(input[1]) of
   'S' : SuperWarpMaker;
   'E' : EditSingleWarps;
   'Q' : Qqq := true;
  end;
 until Qqq;
end;

procedure EditDock;
begin
 DisplayDock;
 writestr('');
 writestr('No changing for now.. Press [ENTER] *');
end;

procedure EditMines;
begin
 Qqq := false;
 if issysop then repeat
  writehdr('Mine Editor');
  writeln('[N]umber of mines');
  writeln('[Q]audrant');
  writeln('[O]wner');
  writeln('[X]it');
  writeln('');
  writestr('Input: *');
  case upcase(input[1]) of
   'N' : ;
   'Q' : ;
   'O' : ;
   'X' : Qqq := true;
  end;
 until Qqq;
end;

procedure EditOrbit;
begin
 writehdr('Orbitals');
end;

procedure EditQuadrant;
begin
 Qqq := false;
 if issysop then repeat
  writehdr('EDIT QUADRANT');
  writeln('[1] Warps');
  writeln('[2] Dock');
  writeln('[3] Mines');
  writeln('[4] Orbitals');
  writeln('[Q] Quit & Save'^m);
  writestr('Input: *');
  case upcase(input[1]) of
   '1' : begin EditWarps end;
   '2' : begin EditDock end;
   '3' : begin EditMines end;
   '4' : begin EditOrbit end;
   'Q' : begin Qqq := true; end;
  end;
 until Qqq;
end;

procedure Test_Quads;
var Qqqq : boolean;
begin
 Qqqq := false;
 clrscr;
 writehdr('SpacePirates v0.07b');
 Input := '1';
 if issysop then Repeat
  loadQuad(str_to_int(input));
  Display_Quad;
  writestr('');
  writestr('>>> Quadrant Testing [Enter #,Q,E]');
  writestr('>>> Input: *');
  if upcase(input[1])='Q' then Qqqq := true;
  if upcase(input[1])='E' then EditQuadrant;
 until Qqqq;
end;

function GetaValue : integer;
begin
 writestr('Enter Value: *');
 GetaValue := str_to_int(input);
end;

procedure EditSpaceStats;
begin
 Qqq := false;
 repeat
  writehdr('Change Space Stats');
  writeln ('[C]redits, [Q]uad, [X]it');
  writeln ('');
  writestr('Input: *');
  case upcase(input[1]) of
   'C' : urec.credits := GetaValue;
   'Q' : urec.quad    := GetaValue;
   'X' : Qqq := true;
  end;
 until Qqq;
end;

function cango(blah : integer) :boolean;
var qaz : integer;
begin
 cango := false;
 for qaz := 1 to 20 do
  if curquad.warps[qaz] = blah then cango := true;
end;

procedure Move_Ship;
var wanna : integer;
begin
 LoadQuad(urec.quad);
 writestr('You are in Quadrant   '^P'['^S+int_to_str(curquad.num)+^P'].');
 writestr('Accessible Quadrants: '+ShowQuadz);
 writestr('');
 writestr('Warp to which Quadrant? *');
 if input <> '' then begin
  wanna := str_to_int(input);
  if cango(wanna) then LoadQuad(wanna)
  else writeln('Quad not available.'); {!!! autopilot}
 end;
end;

BEGIN
END.
